DestroyusPro.oneItemOnStack = 1
DestroyusPro.numberNotExist = 999999999
DestroyusPro.basicReqLvl = 1
DestroyusPro.basicItemIlvl = -1
DestroyusPro.basicTextureNumber = 1 --Legion
DestroyusPro.basicVendorPrice = 1
DestroyusPro.unknowStr = "?Unknow!"
DestroyusPro.falseValue = false

DestroyusPro.strToNumQuality = {}
DestroyusPro.strToNumQuality["rare"] = 3
DestroyusPro.strToNumQuality["epic"] = 4
DestroyusPro.strToNumQuality["uncommon"] = 2
DestroyusPro.strToNumQuality["common"] = 1

-- Temporary for translate TODO delete after translating 
DestroyusPro.strToNumQuality["3"] = 3
DestroyusPro.strToNumQuality["4"] = 4
DestroyusPro.strToNumQuality["2"] = 2
DestroyusPro.strToNumQuality["1"] = 1
-------------------------------------

DestroyusPro.numToStrQuality = {}
DestroyusPro.numToStrQuality[1] = "common"
DestroyusPro.numToStrQuality[2] = "uncommon"
DestroyusPro.numToStrQuality[3] = "rare"
DestroyusPro.numToStrQuality[4] = "epic"

ExtraTabFun.setDefault(DestroyusPro.itemClassWeapon, false)
ExtraTabFun.setDefault(DestroyusPro.itemClassArmor, false)
ExtraTabFun.setDefault(DestroyusPro.itemClassMiscellaneous, false)
ExtraTabFun.setDefault(DestroyusPro.strToNumQuality, -1)
ExtraTabFun.setDefault(DestroyusPro.numToStrQuality, "?unknow!")

DestroyusPro.unknowItemInfo = {DestroyusPro.unknowStr,
							   DestroyusPro.unknowStr,
							   DestroyusPro.strToNumQuality["common"],
							   DestroyusPro.basicItemIlvl,
							   DestroyusPro.basicReqLvl,
							   DestroyusPro.unknowStr,
							   DestroyusPro.unknowStr, 
							   DestroyusPro.numberNotExist,
							   DestroyusPro.unknowStr,
							   DestroyusPro.basicTextureNumber, 
							   DestroyusPro.basicVendorPrice ,
							   DestroyusPro.numberNotExist}

DestroyusPro.unknowContainerItemInfo = {DestroyusPro.unknowStr,
									    DestroyusPro.numberNotExist,
										DestroyusPro.falseValue,
										DestroyusPro.strToNumQuality["common"],
										DestroyusPro.falseValue,
										DestroyusPro.falseValue,
										DestroyusPro.unknowStr,
										DestroyusPro.falseValue,
										DestroyusPro.falseValue,
										DestroyusPro.numberNotExist}
							   
function DestroyusPro.isItemNotSellable(isSellable)
	return not isSellable
end

function DestroyusPro.isQualityAllowed(quality)
	return (quality >= DestroyusPro.strToNumQuality["uncommon"] and quality <= _G["DestroyusProItemQualityValue"])
end

function DestroyusPro.isNotUniqueItem(itemId, uniqueItemList)
	local result = true
	for	_, uniqueItemId in ipairs(uniqueItemList) do
		if uniqueItemId == itemId then
		    result = false
		break
		end
	end
	return result 
end

function DestroyusPro.isOnlyOneMaxStack(maxStack)
	return maxStack == DestroyusPro.oneItemOnStack
end

function DestroyusPro.isItem(class, subClass, equipSlot)
	return DestroyusPro.isWeapon(class, subClass) or 
	       DestroyusPro.isArmor(class, subClass) or
	       DestroyusPro.isMiscellaneous(class, subClass, equipSlot)
end

function DestroyusPro.isWeapon(class, subClass)
	return DestroyusPro.itemClassWeapon[class] and 
	       DestroyusPro.itemClassWeapon[subClass]
end

function DestroyusPro.isArmor(class, subClass)
	return DestroyusPro.itemClassArmor[class] and 
		   DestroyusPro.itemClassArmor[subClass]
end

function DestroyusPro.isMiscellaneous(class, subClass, equipSlot)
	return DestroyusPro.itemClassMiscellaneous[class] and 
		   DestroyusPro.itemClassMiscellaneous[subClass] and
	       DestroyusPro.itemClassMiscellaneous[equipSlot]
end

function DestroyusPro.isItemEquippable(itemId)
	return IsEquippableItem(itemId)
end

function DestroyusPro.getItemProffLvlToDisUncommon(itemILvl)
	local result = 1
	if 1 <= itemILvl and itemILvl <= 20 then
		result = 1
	elseif 21 <= itemILvl and itemILvl <= 25 then
		result = 25
	elseif 26 <= itemILvl and itemILvl <= 30 then
		result = 50
	elseif 31 <= itemILvl and itemILvl <= 35 then
		result = 75
	elseif 36 <= itemILvl and itemILvl <= 40 then
		result = 100
	elseif 41 <= itemILvl and itemILvl <= 45 then
		result = 125
	elseif 46 <= itemILvl and itemILvl <= 50 then
		result = 150
	elseif 51 <= itemILvl and itemILvl <= 55 then
		result = 175
	elseif 56 <= itemILvl and itemILvl <= 60 then
		result = 200
	elseif 61 <= itemILvl and itemILvl <= 101 then
		result = 225
	elseif 102 <= itemILvl and itemILvl <= 120 then
		result = 275
	elseif 121 <= itemILvl and itemILvl <= 150 then
		result = 325
	elseif 151 <= itemILvl and itemILvl <= 271 then
		result = 350
	elseif 272 <= itemILvl and itemILvl <= 363 then
		result = 425
	elseif 364 <= itemILvl and itemILvl <= 469 then
		result = 475
	elseif 470 <= itemILvl then
		result = 1
	else
		result = DestroyusPro.getItemProffLvlToDisRest(itemILvl)		
	end
	return result
end

function DestroyusPro.getItemProffLvlToDisRare(itemILvl)
	local result = 1
	if 1 <= itemILvl and itemILvl <= 25 then
		result = 25
	elseif 26 <= itemILvl and itemILvl <= 30 then
		result = 50
	elseif 31 <= itemILvl and itemILvl <= 35 then
		result = 75
	elseif 36 <= itemILvl and itemILvl <= 40 then
		result = 100
	elseif 41 <= itemILvl and itemILvl <= 45 then
		result = 125
	elseif 46 <= itemILvl and itemILvl <= 50 then
		result = 150
	elseif 51 <= itemILvl and itemILvl <= 55 then
		result = 175
	elseif 56 <= itemILvl and itemILvl <= 60 then
		result = 200
	elseif 61 <= itemILvl and itemILvl <= 99 then
		result = 225
	elseif 100 <= itemILvl and itemILvl <= 124 then
		result = 275
	elseif 125 <= itemILvl and itemILvl <= 218 then
		result = 325
	elseif 219 <= itemILvl and itemILvl <= 377 then
		result = 450
	elseif 378 <= itemILvl and itemILvl <= 424 then
		result = 525
	elseif 425 <= itemILvl and itemILvl <= 505 then
		result = 550
	elseif 506 <= itemILvl then
		result = 1
	else
		result = DestroyusPro.getItemProffLvlToDisRest(itemILvl)		
	end
	return result
end

function DestroyusPro.getItemProffLvlToDisEpic(itemILvl)
	local result = 1
	if 1 <= itemILvl and itemILvl <= 35 then
		result = 25
	elseif 36 <= itemILvl and itemILvl <= 40 then
		result = 100
	elseif 41 <= itemILvl and itemILvl <= 45 then
		result = 125
	elseif 46 <= itemILvl and itemILvl <= 50 then
		result = 150
	elseif 51 <= itemILvl and itemILvl <= 55 then
		result = 175
	elseif 56 <= itemILvl and itemILvl <= 60 then
		result = 200
	elseif 61 <= itemILvl and itemILvl <= 99 then
		result = 225
	elseif 100 <= itemILvl and itemILvl <= 199 then
		result = 300
	elseif 200 <= itemILvl and itemILvl <= 350 then
		result = 375
	elseif 351 <= itemILvl and itemILvl <= 419 then
		result = 475
	elseif 420 <= itemILvl and itemILvl <= 629 then
		result = 575
	elseif 630 <= itemILvl then
		result = 1
	else
		result = DestroyusPro.getItemProffLvlToDisRest(itemILvl)	
	end
	return result
end

function DestroyusPro.getItemProffLvlToDisRest(itemILvl)
	return DestroyusPro.numberNotExist
end

DestroyusPro.selectQualityProfIlvl = {}
DestroyusPro.selectQualityProfIlvl[DestroyusPro.strToNumQuality["uncommon"]] = DestroyusPro.getItemProffLvlToDisUncommon 
DestroyusPro.selectQualityProfIlvl[DestroyusPro.strToNumQuality["rare"]] = DestroyusPro.getItemProffLvlToDisRare
DestroyusPro.selectQualityProfIlvl[DestroyusPro.strToNumQuality["epic"]] = DestroyusPro.getItemProffLvlToDisEpic
ExtraTabFun.setDefault(DestroyusPro.selectQualityProfIlvl, DestroyusPro.getItemProffLvlToDisRest)

function DestroyusPro.getItemProffLvlToDis(itemILvl, quality)
   itemILvl = itemILvl ~= nil and itemILvl or -1
   return DestroyusPro.selectQualityProfIlvl[quality](itemILvl)
end

function DestroyusPro.haveItemRequiredProfLvlDisenchant(profSkillId, itemlvl, quality)
    local result = true
	local proffesionTabIds = DestroyusPro.getProffessionsId()
	local firstProffesion = DestroyusPro.getProffessionInfo(proffesionTabIds["firstProffesion"])
	local secondProffesion =  DestroyusPro.getProffessionInfo(proffesionTabIds["secondProffesion"])
	if firstProffesion["profSkillId"] == profSkillId then
		result = DestroyusPro.getItemProffLvlToDis(itemlvl, quality) <= firstProffesion["skillLevel"]
	elseif secondProffesion["profSkillId"] == profSkillId then
		result = DestroyusPro.getItemProffLvlToDis(itemlvl, quality) <= secondProffesion["skillLevel"]
	else
		result = false
	end
	return result
end

function DestroyusPro.createItemInfoTab(itemId)
	local itemValues = itemId ~= DestroyusPro.numberNotExist and {GetItemInfo(itemId)} or DestroyusPro.unknowItemInfo
	local itemInfoTab = {}
	itemInfoTab["name"] = itemValues[1] ~= nil and itemValues[1] or DestroyusPro.unknowItemInfo[1]
	itemInfoTab["link"] = itemValues[2] ~= nil and itemValues[2] or DestroyusPro.unknowItemInfo[2]
	itemInfoTab["quality"] = itemValues[3] ~= nil and itemValues[3] or DestroyusPro.unknowItemInfo[3] 
	itemInfoTab["ilevel"] = itemValues[4] ~= nil and itemValues[4] or DestroyusPro.unknowItemInfo[4]
	itemInfoTab["reqlevel"] = itemValues[5] ~= nil and itemValues[5] or DestroyusPro.unknowItemInfo[5] 
	itemInfoTab["class"] = itemValues[6] ~= nil and itemValues[6] or DestroyusPro.unknowItemInfo[6]
	itemInfoTab["subclass"] = itemValues[7] ~= nil and itemValues[7] or DestroyusPro.unknowItemInfo[7] 
	itemInfoTab["maxstack"] = itemValues[8] ~= nil and itemValues[8] or  DestroyusPro.unknowItemInfo[8]
	itemInfoTab["equipslot"] = itemValues[9] ~= nil and itemValues[9] or DestroyusPro.unknowItemInfo[9] 
	itemInfoTab["texture"] = itemValues[10] ~= nil and itemValues[10] or DestroyusPro.unknowItemInfo[10] 
	itemInfoTab["vendorprice"] = itemValues[11] ~= nil and itemValues[11] or DestroyusPro.unknowItemInfo[11] 
	itemInfoTab["argUnknow"] = itemValues[12] ~= nil and itemValues[12] or  DestroyusPro.unknowItemInfo[12] 
	return itemInfoTab
end

function DestroyusPro.createContainerItemInfoTab(i, j) 
	local itemValues = {GetContainerItemInfo(i,j)}
	local itemInfoTab = {}
	itemInfoTab["texture"] = itemValues[1] ~= nil and itemValues[1] or DestroyusPro.unknowContainerItemInfo[1]
	itemInfoTab["count"] = itemValues[2] ~= nil and itemValues[2] or DestroyusPro.unknowContainerItemInfo[2]
	itemInfoTab["locked"] = itemValues[3] ~= nil and itemValues[3] or DestroyusPro.unknowContainerItemInfo[3]
	itemInfoTab["quality"] = itemValues[4] ~= nil and itemValues[4] or DestroyusPro.unknowContainerItemInfo[4]
	itemInfoTab["readable"] = itemValues[5] ~= nil and itemValues[5] or DestroyusPro.unknowContainerItemInfo[5]
	itemInfoTab["lootable"] = itemValues[6] ~= nil and itemValues[6] or DestroyusPro.unknowContainerItemInfo[6]
	itemInfoTab["link"] = itemValues[7] ~= nil and itemValues[7] or DestroyusPro.unknowContainerItemInfo[7]
	itemInfoTab["isFiltered"] = itemValues[8] ~= nil and itemValues[8] or DestroyusPro.unknowContainerItemInfo[8]
	itemInfoTab["isNotSellable"] = itemValues[9] ~= nil and itemValues[9] or DestroyusPro.unknowContainerItemInfo[9]
	itemInfoTab["itemId"] = itemValues[10] ~= nil and itemValues[10] or DestroyusPro.unknowContainerItemInfo[10]
	return itemInfoTab
end