local ASCII_0_NUMBER = 48
local ASCII_9_NUMBER = 57
SLASH_DISENCH1 = '/disenchantus' --disenchantus
SLASH_MILLINGUS1 = '/millingus'  --millingus
SLASH_PROSPECTINGUS1 = '/prospectingus'  --prospectingus
SLASH_DESTROYUSPRO1 = '/destroyuspro'  --destroyuspro

local function changeQualityDisenchanting(quality)
	_G["DestroyusProItemQualityValue"] = DestroyusPro.strToNumQuality[quality]
	ReloadUI()
end

local function unknownCommand(command)
    if command == nil then
		command = ""
	end
	local commandMsg = "Uknown value for the command: %s" -- TODO Tanslate
	print(commandMsg:format(command))
end

local function createMacroDisenchanting()
	if _G["DestroyusProDisenchantMacroId"] ~= nil then
		DeleteMacro(_G["DestroyusProDisenchantMacroId"])
	end
		_G["DestroyusProDisenchantMacroId"] = CreateMacro("Disenchantus", "645142", "/click ClickMeForWorkDisenchanting")
	ReloadUI()
end

local function createMacroMiling()
	if _G["DestroyusProMillingMacroId"] ~= nil then
		DeleteMacro(_G["DestroyusProMillingMacroId"])
	end
	_G["DestroyusProMillingMacroId"] = CreateMacro("Millingus", "237031", "/click ClickMeForWorkMilling")
	ReloadUI()
end

local function createMacroProspecting()
	if _G["DestroyusProProspectingusMacroId"] ~= nil then
		DeleteMacro(_G["DestroyusProProspectingusMacroId"])
	end
	_G["DestroyusProProspectingusMacroId"] = CreateMacro("Prospectingus", "133287", "/click ClickMeForWorkProspecting")
	ReloadUI()
end

local function changeStateForPrintout(msg)
	if msg == "offinfo" then
		_G["DestroyusProPrintOutState"] = false
	end
	if msg == "oninfo" then
		_G["DestroyusProPrintOutState"] = true
	end
	ReloadUI()
end

commandsDisenchanting = {}
commandsDisenchanting["uncommon"] = changeQualityDisenchanting
commandsDisenchanting["rare"] = changeQualityDisenchanting
commandsDisenchanting["epic"] = changeQualityDisenchanting
commandsDisenchanting["macro"] = createMacroDisenchanting

-- Quick fix for the transalting TODO
commandsDisenchanting["2"] = changeQualityDisenchanting
commandsDisenchanting["3"] = changeQualityDisenchanting
commandsDisenchanting["4"] = changeQualityDisenchanting
-- end


commandsMilling = {}
commandsMilling["macro"] = createMacroMiling

commandsProspecting = {}
commandsProspecting["macro"] = createMacroProspecting

commandsDestroyusPro = {}
commandsDestroyusPro["offinfo"] = changeStateForPrintout
commandsDestroyusPro["oninfo"] = changeStateForPrintout

ExtraTabFun.setDefault(commandsDisenchanting, unknownCommand)
ExtraTabFun.setDefault(commandsMilling, unknownCommand)
ExtraTabFun.setDefault(commandsProspecting, unknownCommand)
ExtraTabFun.setDefault(commandsDestroyusPro, unknownCommand)

local function commandHandler(msg, editBox)
	commandsDisenchanting[msg](msg)
end

local function commandHandlerMilling(msg, editBox)
	commandsMilling[msg](msg)
end

local function commandHandlerProspecting(msg, editBox)
	commandsProspecting[msg](msg)
end

local function commandHandlerDestroyusPro(msg, editBox)
	commandsDestroyusPro[msg](msg)
end

SlashCmdList["DISENCH"] = commandHandler
SlashCmdList["MILLINGUS"] = commandHandlerMilling
SlashCmdList["PROSPECTINGUS"] = commandHandlerProspecting
SlashCmdList["DESTROYUSPRO"] = commandHandlerDestroyusPro